import { PropsWithChildren } from 'react';
import type { Attachment } from 'stream-chat';
export declare type CardProps = {
    giphy?: Attachment['giphy'];
    /** The url of the full sized image */
    image_url?: string;
    /** The scraped url, used as a fallback if the OG-data doesn't include a link */
    og_scrape_url?: string;
    /** Description returned by the OG scraper */
    text?: string;
    /** The url for thumbnail sized image */
    thumb_url?: string;
    /** Title returned by the OG scraper */
    title?: string;
    /** Link returned by the OG scraper */
    title_link?: string;
    /** The card type used in the className attribute */
    type?: string;
};
/**
 * Simple Card Layout for displaying links
 */
export declare const Card: (props: PropsWithChildren<CardProps>) => JSX.Element | null;
//# sourceMappingURL=Card.d.ts.map