var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useCallback, useEffect, useMemo, useRef, useState } from 'react';
import { MessageDeleted as DefaultMessageDeleted } from './MessageDeleted';
import { MessageRepliesCountButton as DefaultMessageRepliesCountButton } from './MessageRepliesCountButton';
import { MessageTimestamp as DefaultTimestamp } from './MessageTimestamp';
import { useReactionClick } from './hooks';
import { PinIndicator as DefaultPinIndicator, ErrorIcon, ReactionIcon, ThreadIcon } from './icons';
import { QuotedMessage as DefaultQuotedMessage } from './QuotedMessage';
import { areMessageUIPropsEqual, MESSAGE_ACTIONS, showMessageActionsBox } from './utils';
import { Avatar as DefaultAvatar } from '../Avatar';
import { CUSTOM_MESSAGE_TYPE } from '../../constants/messageTypes';
import { MessageActions } from '../MessageActions';
import { EditMessageForm as DefaultEditMessageForm, MessageInput } from '../MessageInput';
import { ReactionSelector as DefaultReactionSelector, SimpleReactionsList as DefaultReactionsList, } from '../Reactions';
import { useComponentContext } from '../../context/ComponentContext';
import { useMessageContext } from '../../context/MessageContext';
import { useTranslationContext } from '../../context/TranslationContext';
import { renderText as defaultRenderText, isOnlyEmojis } from '../../utils';
var MessageLivestreamWithContext = function (props) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    var clearEditingState = props.clearEditingState, editing = props.editing, groupStyles = props.groupStyles, handleAction = props.handleAction, handleOpenThread = props.handleOpenThread, handleRetry = props.handleRetry, initialMessage = props.initialMessage, isReactionEnabled = props.isReactionEnabled, message = props.message, messageWrapperRef = props.messageWrapperRef, onMentionsClickMessage = props.onMentionsClickMessage, onMentionsHoverMessage = props.onMentionsHoverMessage, onReactionListClick = props.onReactionListClick, onUserClick = props.onUserClick, onUserHover = props.onUserHover, reactionSelectorRef = props.reactionSelectorRef, _l = props.renderText, renderText = _l === void 0 ? defaultRenderText : _l, showDetailedReactions = props.showDetailedReactions, unsafeHTML = props.unsafeHTML;
    var _m = useComponentContext('MessageLivestream'), Attachment = _m.Attachment, _o = _m.Avatar, Avatar = _o === void 0 ? DefaultAvatar : _o, _p = _m.EditMessageInput, EditMessageInput = _p === void 0 ? DefaultEditMessageForm : _p, _q = _m.MessageDeleted, MessageDeleted = _q === void 0 ? DefaultMessageDeleted : _q, _r = _m.MessageRepliesCountButton, MessageRepliesCountButton = _r === void 0 ? DefaultMessageRepliesCountButton : _r, _s = _m.PinIndicator, PinIndicator = _s === void 0 ? DefaultPinIndicator : _s, _t = _m.QuotedMessage, QuotedMessage = _t === void 0 ? DefaultQuotedMessage : _t, _u = _m.ReactionsList, ReactionsList = _u === void 0 ? DefaultReactionsList : _u, _v = _m.ReactionSelector, ReactionSelector = _v === void 0 ? DefaultReactionSelector : _v;
    var _w = useTranslationContext('MessageLivestream'), t = _w.t, userLanguage = _w.userLanguage;
    var messageTextToRender = ((_a = message.i18n) === null || _a === void 0 ? void 0 : _a[userLanguage + "_text"]) || message.text;
    var messageText = useMemo(function () { return renderText(messageTextToRender, message.mentioned_users); }, [
        message.mentioned_users,
        messageTextToRender,
    ]);
    var firstGroupStyle = groupStyles ? groupStyles[0] : 'single';
    if (message.customType === CUSTOM_MESSAGE_TYPE.date) {
        return null;
    }
    if (message.deleted_at) {
        return React.createElement(MessageDeleted, { message: message });
    }
    if (editing) {
        return (React.createElement("div", { className: "str-chat__message-team str-chat__message-team--" + firstGroupStyle + " str-chat__message-team--editing", "data-testid": 'message-livestream-edit' },
            (firstGroupStyle === 'top' || firstGroupStyle === 'single') && (React.createElement("div", { className: 'str-chat__message-team-meta' },
                React.createElement(Avatar, { image: (_b = message.user) === null || _b === void 0 ? void 0 : _b.image, name: ((_c = message.user) === null || _c === void 0 ? void 0 : _c.name) || ((_d = message.user) === null || _d === void 0 ? void 0 : _d.id), onClick: onUserClick, onMouseOver: onUserHover, size: 40 }))),
            React.createElement(MessageInput, { clearEditingState: clearEditingState, Input: EditMessageInput, message: message })));
    }
    return (React.createElement(React.Fragment, null,
        message.pinned && (React.createElement("div", { className: 'str-chat__message-livestream-pin-indicator' },
            React.createElement(PinIndicator, { message: message, t: t }))),
        React.createElement("div", { className: "str-chat__message-livestream str-chat__message-livestream--" + firstGroupStyle + " str-chat__message-livestream--" + message.type + " str-chat__message-livestream--" + message.status + " " + (initialMessage ? 'str-chat__message-livestream--initial-message' : '') + " " + (message.pinned ? 'pinned-message' : ''), "data-testid": 'message-livestream', ref: messageWrapperRef },
            showDetailedReactions && isReactionEnabled && (React.createElement(ReactionSelector, { ref: reactionSelectorRef })),
            React.createElement(MessageLivestreamActions, { messageWrapperRef: messageWrapperRef, onReactionListClick: onReactionListClick }),
            React.createElement("div", { className: 'str-chat__message-livestream-left' },
                React.createElement(Avatar, { image: (_e = message.user) === null || _e === void 0 ? void 0 : _e.image, name: ((_f = message.user) === null || _f === void 0 ? void 0 : _f.name) || ((_g = message.user) === null || _g === void 0 ? void 0 : _g.id), onClick: onUserClick, onMouseOver: onUserHover, size: 30 })),
            React.createElement("div", { className: 'str-chat__message-livestream-right' },
                React.createElement("div", { className: 'str-chat__message-livestream-content' },
                    React.createElement("div", { className: 'str-chat__message-livestream-author' },
                        React.createElement("strong", null, ((_h = message.user) === null || _h === void 0 ? void 0 : _h.name) || ((_j = message.user) === null || _j === void 0 ? void 0 : _j.id)),
                        message.type === 'error' && (React.createElement("div", { className: 'str-chat__message-team-error-header' }, t('Only visible to you')))),
                    React.createElement("div", { className: isOnlyEmojis(message.text) ? 'str-chat__message-livestream-text--is-emoji' : '', "data-testid": 'message-livestream-text', onClick: onMentionsClickMessage, onMouseOver: onMentionsHoverMessage },
                        message.quoted_message && (React.createElement("div", { className: 'livestream-quoted-message' },
                            React.createElement(QuotedMessage, null))),
                        message.type !== 'error' &&
                            message.status !== 'failed' &&
                            !unsafeHTML &&
                            messageText,
                        message.type !== 'error' &&
                            message.status !== 'failed' &&
                            unsafeHTML &&
                            !!message.html && React.createElement("div", { dangerouslySetInnerHTML: { __html: message.html } }),
                        message.type === 'error' && !message.command && (React.createElement("p", { "data-testid": 'message-livestream-error' },
                            React.createElement(ErrorIcon, null),
                            message.text)),
                        message.type === 'error' && message.command && (React.createElement("p", { "data-testid": 'message-livestream-command-error' },
                            React.createElement(ErrorIcon, null),
                            React.createElement("strong", null,
                                "/",
                                message.command),
                            " is not a valid command")),
                        message.status === 'failed' && (React.createElement("p", { onClick: message.errorStatusCode !== 403 ? function () { return handleRetry(message); } : undefined },
                            React.createElement(ErrorIcon, null),
                            message.errorStatusCode !== 403
                                ? t('Message Failed · Click to try again')
                                : t('Message Failed · Unauthorized')))),
                    ((_k = message.attachments) === null || _k === void 0 ? void 0 : _k.length) ? (React.createElement(Attachment, { actionHandler: handleAction, attachments: message.attachments })) : null,
                    isReactionEnabled && React.createElement(ReactionsList, null),
                    !initialMessage && (React.createElement(MessageRepliesCountButton, { onClick: handleOpenThread, reply_count: message.reply_count })))))));
};
var MessageLivestreamActions = function (props) {
    var messageWrapperRef = props.messageWrapperRef, onReactionListClick = props.onReactionListClick;
    var _a = useComponentContext('MessageLivestream').MessageTimestamp, MessageTimestamp = _a === void 0 ? DefaultTimestamp : _a;
    var _b = useMessageContext('MessageLivestream'), getMessageActions = _b.getMessageActions, handleOpenThread = _b.handleOpenThread, initialMessage = _b.initialMessage, message = _b.message, threadList = _b.threadList;
    var _c = useState(false), actionsBoxOpen = _c[0], setActionsBoxOpen = _c[1];
    var hideOptions = useCallback(function () { return setActionsBoxOpen(false); }, []);
    var messageDeletedAt = !!message.deleted_at;
    var messageWrapper = messageWrapperRef === null || messageWrapperRef === void 0 ? void 0 : messageWrapperRef.current;
    var messageActions = getMessageActions();
    var showActionsBox = showMessageActionsBox(messageActions);
    var shouldShowReactions = messageActions.indexOf(MESSAGE_ACTIONS.react) > -1;
    var shouldShowReplies = messageActions.indexOf(MESSAGE_ACTIONS.reply) > -1 && !threadList;
    useEffect(function () {
        if (messageWrapper) {
            messageWrapper.addEventListener('mouseleave', hideOptions);
        }
        return function () {
            if (messageWrapper) {
                messageWrapper.removeEventListener('mouseleave', hideOptions);
            }
        };
    }, [messageWrapper, hideOptions]);
    useEffect(function () {
        if (messageDeletedAt) {
            document.removeEventListener('click', hideOptions);
        }
    }, [messageDeletedAt, hideOptions]);
    useEffect(function () {
        if (actionsBoxOpen) {
            document.addEventListener('click', hideOptions);
        }
        else {
            document.removeEventListener('click', hideOptions);
        }
        return function () {
            document.removeEventListener('click', hideOptions);
        };
    }, [actionsBoxOpen, hideOptions]);
    if (initialMessage ||
        !message ||
        message.type === 'error' ||
        message.type === 'system' ||
        message.type === 'ephemeral' ||
        message.status === 'failed' ||
        message.status === 'sending') {
        return null;
    }
    return (React.createElement("div", { className: "str-chat__message-livestream-actions", "data-testid": 'message-livestream-actions' },
        React.createElement(MessageTimestamp, { customClass: 'str-chat__message-livestream-time' }),
        shouldShowReactions && (React.createElement("span", { "data-testid": 'message-livestream-reactions-action', onClick: onReactionListClick },
            React.createElement("span", null,
                React.createElement(ReactionIcon, null)))),
        shouldShowReplies && (React.createElement("span", { "data-testid": 'message-livestream-thread-action', onClick: handleOpenThread },
            React.createElement(ThreadIcon, null))),
        showActionsBox && React.createElement(MessageActions, { inline: true })));
};
var MemoizedMessageLivestream = React.memo(MessageLivestreamWithContext, areMessageUIPropsEqual);
/**
 * @deprecated - This UI component will be removed in the next major release.
 *
 * Handles the rendering of a message and depends on the Message component for all the logic.
 * Implements the look and feel for a livestream use case.
 */
export var MessageLivestream = function (props) {
    var messageContext = useMessageContext('MessageLivestream');
    var messageWrapperRef = useRef(null);
    var reactionSelectorRef = useRef(null);
    var message = props.message || messageContext.message;
    var _a = useReactionClick(message, reactionSelectorRef, messageWrapperRef), isReactionEnabled = _a.isReactionEnabled, onReactionListClick = _a.onReactionListClick, showDetailedReactions = _a.showDetailedReactions;
    return (React.createElement(MemoizedMessageLivestream, __assign({}, messageContext, { isReactionEnabled: isReactionEnabled, messageWrapperRef: messageWrapperRef, onReactionListClick: onReactionListClick, reactionSelectorRef: reactionSelectorRef, showDetailedReactions: showDetailedReactions }, props)));
};
