import React from 'react';
import { StreamMessage } from '../../../context/ChannelStateContext';
import type { ReactEventHandler } from '../types';
import type { DefaultStreamChatGenerics } from '../../../types/types';
export declare const reactionHandlerWarning = "Reaction handler was called, but it is missing one of its required arguments.\nMake sure the ChannelAction and ChannelState contexts are properly set and the hook is initialized with a valid message.";
export declare const useReactionHandler: <StreamChatGenerics extends DefaultStreamChatGenerics = DefaultStreamChatGenerics>(message?: StreamMessage<StreamChatGenerics> | undefined) => (reactionType: string, event?: React.BaseSyntheticEvent<object, any, any> | undefined) => Promise<void>;
export declare const useReactionClick: <StreamChatGenerics extends DefaultStreamChatGenerics = DefaultStreamChatGenerics>(message?: StreamMessage<StreamChatGenerics> | undefined, reactionSelectorRef?: React.RefObject<HTMLDivElement | null> | undefined, messageWrapperRef?: React.RefObject<HTMLDivElement | null> | undefined, closeReactionSelectorOnClick?: boolean | undefined) => {
    isReactionEnabled: boolean;
    onReactionListClick: ReactEventHandler;
    showDetailedReactions: boolean;
};
//# sourceMappingURL=useReactionHandler.d.ts.map